// Функция ymaps.ready() будет вызвана, когда
    // загрузятся все компоненты API, а также когда будет готово DOM-дерево.
    var myMap;
    var placemarkCollections = {};
    var placemarkList = {};
     

     
    ymaps.ready(init);
     
    function init() {
     
        // Создаем карту
        myMap = new ymaps.Map("map", {
            center: [48.486518, 135.115512],
            zoom: 15,
            controls: [
                'zoomControl'
            ],
            zoomMargin: [20]
        });

        // var suggestView1 = new ymaps.SuggestView('suggest', { results: 3});

        for (var i = 0; i < shopList.length; i++) {
     
            // Добавляем название города в список
            $('div#cities').append('<a href="#" id="goto" class="goto" data-goto= ' + i + ' title=' + shopList[i].cityName + '>' + shopList[i].cityName + '</a>')  

            // Создаём коллекцию меток для города
            var cityCollection = new ymaps.GeoObjectCollection();
     
            for (var c = 0; c < shopList[i].shops.length; c++) {
                var shopInfo = shopList[i].shops[c];
     
                var shopPlacemark = new ymaps.Placemark(
                    shopInfo.coordinates,
                    {
                        hintContent: shopInfo.name,
                        balloonContent: shopInfo.name,
                    },
                );
     
                if (!placemarkList[i]) placemarkList[i] = {};
                placemarkList[i][c] = shopPlacemark;
     
                // Добавляем метку в коллекцию
                cityCollection.add(shopPlacemark);
     
            }
     
            placemarkCollections[i] = cityCollection;
     
            // Добавляем коллекцию на карту
            myMap.geoObjects.add(cityCollection);
     
        }
        
    }
     
    // Переключение города
    $('div#cities').on('click', 'a#goto', function () {
        var cityId = $(this).attr('data-goto');
     
        // Масштабируем и выравниваем карту так, чтобы были видны метки для выбранного города
        myMap.setBounds(placemarkCollections[cityId].getBounds(), {checkZoomRange:true}).then(function(){
            if(myMap.getZoom() > 15) myMap.setZoom(15); // Если значение zoom превышает 15, то устанавливаем 15.
        });
     
        // Добавление списка филиалов определенного города
        // $('#shops').html('');
        // for (var c = 0; c < shopList[cityId].shops.length; c++) {
        //     $('#shops').append('<li value="' + c + '">' + shopList[cityId].shops[c].name + '</li>');
        // }
     
    });
     
